#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>

void prpnbs(unsigned n)
{
    int *nums;

    nums = malloc(n - 2);
    if (nums == 0)
    {
        fprintf(stderr, "not enough memory\n");
        return;
    }
    nums -= 2;

    for (int i = 2; i < n; i++)
    {
        nums[i] = 1;
    }

    for (int i = 2; i < n; i++)
    {
        if (nums[i])
        {
            for (int j = 2 * i; j < n; j += i)
            {
                nums[j] = 0;
            }
        }
    }

    for (int i = 2; i < n; i++)
    {
        if (nums[i])
            printf("%d ", i);
    }
    printf("\n");

    nums += 2;
    free(nums);
    nums  = 0;

    return;
}

int main()
{
    prpnbs(100);
}
